#include "destination.h"


Destination::~Destination() {}

Destination::Writer::~Writer() {}

DestinationBuffer::DestinationBuffer(
	const Thread::SharedPtr<SharedObject<std::string> >& buffer) :
		buffer(buffer) {}

Derived<Destination::Writer> DestinationBuffer::getWriter() {
	return Writer(buffer);
}

DestinationBuffer::Writer::Writer(
	const Thread::SharedPtr<SharedObject<std::string> >& buffer) :
		buffer(buffer) {}

DestinationBuffer::Writer::~Writer() {
	SharedObject<std::string>::Lock lock(*buffer);
	lock.get().swap(bufferCopy);
}

void DestinationBuffer::Writer::write(const char* data, size_t size) {
	bufferCopy.append(data,size);
}

DestinationFile::DestinationFile(const std::string& file) : file(file) {}

Derived<Destination::Writer> DestinationFile::getWriter() {
	return Writer(file);
}

DestinationFile::Writer::Writer(const std::string& file) :
	handle(new File(file,"wb")) {}

void DestinationFile::Writer::write(const char* data, size_t size) {
	handle->write(data,size);
}