#include "file.h"


File::File(const std::string& file, const std::string& mode) :
	handle(fopen(file.c_str(),mode.c_str())) {

	if (handle == 0) {
		throw Exception();
	}
}

File::~File() {
	fclose(handle);
}

void File::seek(unsigned long position) {
	if (fseek(handle,position,SEEK_SET)) {
		throw Exception();
	}
}

void File::seekEOF() {
	if (fseek(handle,0,SEEK_END)) {
		throw Exception();
	}
}

unsigned long File::tell() {
	long position = ftell(handle);
	if (position < 0) {
		throw Exception();
	}

	return static_cast<unsigned long>(position);
}

size_t File::size() {
	unsigned long current = tell();

	seekEOF();
	size_t end = tell();
	
	seek(current);
	return end;
}

size_t File::read(char* data, size_t numb) {
	size_t bytes = fread(data,1,numb,handle);
	if (ferror(handle)) {
		throw Exception();
	}

	return bytes;
}

void File::write(const char* data, size_t numb) {
	if (fwrite(data,1,numb,handle) != numb) {
		throw Exception();
	}
}